#include <windows.h>
#include <stdlib.h>
#include <errno.h>

INT WINAPI WinMain (

    HINSTANCE       hInstance,
    HINSTANCE       hPrevInstance,
    PSTR            szCmdLine,
    INT             iCmdShow

) {

    STARTUPINFO si = {sizeof(si)};
    PROCESS_INFORMATION pi = {0};
    char *pszArgs;
    ULONG ulValue;
    DWORD_PTR dwProcess, dwSystem;

    pszArgs = szCmdLine;

    /* Make sure we got a valid cpu index */
    ulValue = 1 << strtoul((const char *) &szCmdLine[0], &pszArgs, 10);
    GetProcessAffinityMask(GetCurrentProcess(), &dwProcess, &dwSystem);
    ulValue &= ulValue & dwSystem;

    if (!ulValue || pszArgs == &szCmdLine[0])
    {
        MessageBox(NULL, "cpcpu <CPU n> <command line>\r\n\r\nn = 0 based CPU index", "USAGE", MB_ICONINFORMATION);
        return ~ERROR_SUCCESS;
    }

    while(*pszArgs && isspace(*pszArgs))
        pszArgs++;
    
    if (*pszArgs)
    {
        CreateProcess(
                        NULL,
                        pszArgs,
                        NULL,
                        NULL,
                        FALSE,
                        CREATE_SUSPENDED,
                        NULL,
                        NULL,
                        &si,
                        &pi
                     );

        /* Handle from CreateProcess is PROCESS_ALL_ACCESS */
        if (pi.hProcess)
        {
            /* Make it run where we want */
            SetProcessAffinityMask(pi.hProcess, ulValue);
            ResumeThread(pi.hThread);

            CloseHandle(pi.hThread);
            CloseHandle(pi.hProcess);
        }
        else
        {
            return GetLastError();
        }
    }
    else
    {
        MessageBox(NULL, "cpcpu <CPU n> <command line>\r\n\r\nn = 0 based CPU index", "USAGE", MB_ICONINFORMATION);
        return ~ERROR_SUCCESS;
    }

    return ERROR_SUCCESS;
}
